/************************************************************************
 *                                                                      *
 *    Copyright (c) 1991 Wilhelm Valder, Regine Freitag, Wolfgang Dzida *
 *                        All rights reserved                           *
 *                                                                      *
 *                                                                      *
 *    Permission to copy this program or any part of this program is    *
 *    granted in case of personal, non-commercial use only. Any use     *
 *    for profit or other commercial gain without written permissions   *
 *    of the authors is prohibited.                                     *
 *                                                                      *
 *    You may freely distribute this program to friends, colleagues,    *
 *    etc.  As a courtesy we would appreciate it if you left our names  *
 *    on the code as the authors.                                       *
 *    We also, of course, disavow any liabilities                       *
 *    for any bizarre things you may choose to do with the system.      *
 *                                                                      *
 *    We would appreciate though your letting us know about any         *
 *    extensions, modifications, project suggestions, etc.              *
 *    Please mail all bugs, comments, complaints and suggestions to:    *
 *                                                                      *
 *                                                                      *
 *    GMD (German National Research Center for Computer Science)        *
 *    Institut fuer Systemtechnik (F2G2)                                *
 *    P.O. Box 1240                                                     *
 *    Schloss Birlinghoven                                              *
 *    D-5205 St. Augustin 1, West Germany                               *
 *                                                                      *
 *    email:    dzida@kmx.gmd.dbp.de                                    *
 *              freitag@gmdzi.uunet                                     *
 *                                                                      *
 ************************************************************************/
/*****************************************************************************
 * This file contains the program to generate the Interface Editors menus;
 * the generated application node "IFE-functions" is stored in file "ife.menu"
 ****************************************************************************/

#include <stdio.h>
#include <exBasics.h>
#include <exErrors.h>
#include <exMenu.h>

extern startEditor();
extern quitEditor();
extern closeIFEditor();
extern quitIFEditor();

Widget top;

main(argc, argv)
     int argc;
     char **argv;
{
  char *getenv();
  char str[200];
  MHmenu *mptr;
  MHitem *iptr;
  MHiReq *req;
  int mask[10];

  top = XtInitialize(NULL, "ife menus",  (XrmOptionDescRec *) NULL, 
		     0, &argc, argv);

  initMDS();
  exInitLayout(XtDisplay(top));
  exInitMenus(XtDisplay(top));

  newApplicationNode("IFE-functions");
  
  insertFunction(currentApplication(), startEditor, "startEditor");
  insertFunction(currentApplication(), quitEditor, "quitEditor");
  insertFunction(currentApplication(), quitIFEditor, "quitIFEditor");


/* ------------------------------------------------------------ */
  mptr = newMenu("quit");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr, MDS_CNT_EQ);
  setSelCnt(mptr, 1);
  sprintf(str, "Option to quit the interface editor.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "quit", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Quit the interface editor.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(quitIFEditor, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

/* ------------------------------------------------------------ */
  mptr = newMenu("editors");
  setMenuType(mptr, MDS_M_PULLD);
  setSelType(mptr, MDS_CNT_EQ);
  setSelCnt(mptr, 1);
  sprintf(str, "Options to start or quit one of the editors.");
  mptr->m_hlp->hlpmsg = strCopy(str);

  iptr = newItem(mptr, "start editor", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Start an editor.\nYou get a menu containing the list of available editors\nfrom which you can select the desired one.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(startEditor, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  iptr = newItem(mptr, "quit editor", EOS); 
  setRetPattern(iptr, "$");
  sprintf(str, "Quit an editor.\nYou get a menu containing the list of running editors\nfrom which you can select the desired one.");
  iptr->i_hlp->hlpmsg = strCopy(str);
  req = makeOneRequest(quitEditor, "", "", 0);
  setReqCnt(req, 1, MDS_CNT_EQ);
  insertRequest(iptr, req, 0);

  setFile(currentApplication(), "ife.menu");
  dumpToFile(top);
  exit(0);
}


closeIFEditor()
{
}

startEditor()
{
}

quitEditor()
{
}

quitIFEditor()
{
}
